//machineEnvClass.h 1996 Brian Bergstrand 07/16/96

class MachineEnv
{
  public:
    MachineEnv ();//constructor - defined externally
    virtual ~MachineEnv () {}//destructor - does nothing
    //public functions to return the machine environment
    long ReturnSysVer (void) const {return sysVer;}
    long ReturnUpdateVer (void) const {return updateVer;}
    long ReturnMachineType (void) const {return machineType;}
    long ReturnProcessor (void) const {return processor;}
    long ReturnRealMem (void) const {return realMem;}
    long ReturnLogicalMem (void) const {return logicalMem;}
    Boolean ReturnVMon (void) const {return VMon;}
    
  protected:
    long sysVer;//system version
    long updateVer;//update version
    long machineType;//type of machine
    long processor;//which PPC processor
    long realMem;//physical memory
    long logicalMem;//logical memory
    Boolean VMon;//virtual memory on or off
    
  private:
    /*The following functions are added so copies of objects can not
      be made, pass/copy by reference when the need to arises. This is done
      so we don't run into unforseen trouble by making a shallow copy, when 
      we should have made a deep ((this) is assigned separate heap space) copy*/
    
    MachineEnv (MachineEnv &) {}//copy constructor
    MachineEnv & operator=(MachineEnv &) {return *this;}//= overloader 
};